

XIMButton = 
{
    Up                = 0,
    Down              = 0,
    Left              = 0,
    Right             = 0,
    Start             = 0,
    Back              = 0,
    LS                = 0,
    RS                = 0,
    LB                = 0,
    RB                = 0,
    Guide             = 0,
    A                 = 0,
    B                 = 0,
    X                 = 0,
    Y                 = 0,
}

XIMAnalog = {
	RSX  = 0,
    RSY  = 0,
    LSX  = 0,
    LSY  = 0,
    RT   = 0,
    LT   = 0,
}

XIMValue = {
    ButtonCount             = 16,

    StickRest                 = 0,
    StickRightMost            = 32767,
    StickLeftMost             = -32767,
    StickUpMost               = 32767,
    StickDownMost             = -32767,
    
    StickMaximum              = 32767,
    StickMinimum              = -32767,

    TriggerRest                = 0,
    TriggerMost                = 255,

    TriggerMinimum             = 0,
    TriggerMaximum             = 255,
}

WeaponType = {
  A = 0,
  HA= 1,
  R = 2,
  HR= 3,
  H =-2,
  HH=-1,
}


function waitLoad(bWaitStartLoad)
  if bWaitStartLoad == nil then
    bWaitStartLoad = false
  end

--  print ("wait load icon")

  local timeEndLoad = msec()
  while isLoadIcon(0.3) == false 
        and ( bWaitStartLoad == true or msec() - timeEndLoad <= 1000 ) do
    coroutine.yield()
  end
  
  timeEndLoad = msec()
  while msec()- timeEndLoad <= 1000 do
    if isLoadIcon(0.3) == true then
	  timeEndLoad = msec()
	end
    coroutine.yield()
  end
  
end

function waitLoadMission()
  print ("wait load mission")

  while recText(480, 46, 100, 26) ~= "NOW" do 
    coroutine.yield()
  end
  
  local timeEndLoad = msec()  
  while msec()- timeEndLoad <= 800 do
    if recText(480, 46, 100, 26) == "NOW" then
	  timeEndLoad = msec()
	end
    coroutine.yield()
  end  
end

function waitGoto(text)  
  print ("wait goto ", text)
  local fixText = string.gsub(text, "[^%w]", "")
  while string.gsub(recText3(116, 56, 280, 23,thld), "[^%w]", "") ~= fixText do
	coroutine.yield()
  end

end

function buy(growth)
  click(OK)
  msleep(1000)
  
  if growth > 0 then
    click("Up")
    for i = 1, growth do
      click("Right")
    end
    click("Down")
  elseif growth < 0 then
    click("Up")
    for i = -1,growth,-1 do
      click("Left")
    end
    click("Down")
  else
    click("Left")
  end

  click(OK)
  waitLoad(true)
  msleep(100)
end

function sell(bNotSell)
    rec_attack    = recInteger(600,169,70,20)
	rec_impact    = recInteger(600,194,70,20)
	rec_reload    = recInteger(600,244,70,20)
	rec_lockon    = recInteger(600,269,70,20)
	rec_speed     = recInteger(600,294,70,20)
	rec_range     = recInteger(600,319,70,20)
	rec_stability = recInteger(600,369,70,20)
    rec_ensuply   = recInteger(600,394,70,20)
	
	
	print("attack   ",rec_attack    )
	print("impact   ",rec_impact    )
	print("reload   ",rec_reload    )
	print("lockon   ",rec_lockon    )
	print("speed    ",rec_speed     )
	print("range    ",rec_range     )
	print("stability",rec_stability )
	print("ensuply  ",rec_ensuply   )
	
    if (bNotSell ~= nil and bNotSell == true) then
	   click("Down")
	elseif
	   ( attack    ~= nil and rec_attack    ~= nil and attack    > rec_attack ) or
	   ( impact    ~= nil and rec_impact    ~= nil and impact    > rec_impact ) or
	   ( reload    ~= nil and rec_reload    ~= nil and reload    < rec_reload ) or
	   ( lockon    ~= nil and rec_lockon    ~= nil and lockon    < rec_lockon ) or
	   ( speed     ~= nil and rec_speed     ~= nil and speed     > rec_speed  ) or
	   ( range     ~= nil and rec_range     ~= nil and range     > rec_range  ) or
	   ( stability ~= nil and rec_stability ~= nil and stability > rec_stability ) or 
	   ( ensuply   ~= nil and rec_ensuply   ~= nil and ensuply   < rec_ensuply )
	then
	  click(OK)
	  msleep(800)
	  click("Left")
	  msleep(100)
	  click(OK)
	  waitLoad()
	else
      click("Down")
	end
	msleep(800)
end

function mission(weaponChange)

  if weaponChange == nil then
    weaponChange = true
  end

  -- world menu
  click(OK)
  waitGoto("CONQUEST")
  waitLoad()
  msleep(200)
  click("Down")
  msleep(100)
  click("Down")
  msleep(100)
  click("Down")
  msleep(100)
  click("Down")
  msleep(100)
  click(OK)
 
  XIMAnalog.LSX = XIMValue.StickLeftMost*4/5
  msleep(825)
  XIMAnalog.LSX = XIMValue.StickRest
  XIMAnalog.LSY = XIMValue.StickDownMost*4/5
  msleep(460)
  XIMAnalog.LSY = XIMValue.StickRest
  msleep(400)
  click(OK,180)
  msleep(400)
  click(OK,180)


  -- edit party
  waitGoto("CORPS COMPOSE")
  waitLoad()
  click(OK)
  msleep(400)
  click("Left",180)
  click(OK) 

  -- briefing
  waitGoto("BRIEFING")
  waitLoad()

  if weaponChange == true then   
    click("Down") 
    click(OK)
   
    -- garage
    waitGoto("ASSEMBLE")
    msleep(100)
    click("Down") -- right arm weapon
    click("Down")
    click(OK)
    click("Right") -- left arm weapon
    click("Down")
    click("Down")
    click(OK)
    click("Right") -- right hanger weapon
    click("Right")
    click("Right")
    click("Down")
    click("Down")
    click(OK)
    click("Right") -- left hanger weapon
    click("Down")
    click("Down")
    click(OK)
	msleep(200)
    click(CANCEL,180)
	msleep(200)
    click(CANCEL,180)
	msleep(200)
    waitLoad()

    -- briefing
    waitGoto("BRIEFING")
    click("Up")    
  end
  
  click(OK)
  msleep(400)
  click("Left")
  click(OK) 

  -- mission start
  waitLoadMission()
  click(START,180)
  msleep(400)
  click(OK);
  
  msleep(6000);
  XIMAnalog.LSX = XIMValue.StickLeftMost
  XIMButton.X = 1
  msleep(10000);
  XIMAnalog.LSX = XIMValue.StickRest
  XIMButton.X = 0
  
  -- mission report
  waitGoto("MISSION REPORT")
  waitLoad()
  click(OK)
  msleep(400)
  click(OK)  
 
  waitLoad();
  waitGoto("WORLD MENU")
  waitLoad()
  waitLoad()
  msleep(200)
  
end


function click(button, t)
  if t == nil then
    tPush = 112
	tPull = 96
  else
    tPush = t
	tPull = t
  end
  XIMButton[button] = 1
  msleep(tPush)
  XIMButton[button] = 0
  msleep(tPull)
end

function clickTrigger(trigger)
  XIMAnalog[trigger] = XIMValue.TriggerMost
  msleep(200)
  XIMAnalog[trigger] = XIMValue.TriggerRest
  msleep(200)
end

function msleep(t)
  local stime = msec()
  repeat
    coroutine.yield()
  until msec() - stime > t	
end

function recInteger(x,y,w,h)
  local text = recText3(x,y,w,h,thld)
--  print ("rec",text)
  local text = string.gsub(text, "(%d+)[^%d]?(%d+)", "%1%2", 1)

  local integer = tonumber(text)
  
  if integer == nil then
    return nil
  end
  return integer
end 

function moveWeaponInShop()
  click(OK)
  msleep(200)
  clickTrigger("RT")
  click("Left")
  click("Right")
end


function doAll()

  click(OK)  
  waitGoto("BUY PARTS")
  waitLoad()
  msleep(400)
  
  moveWeaponInShop()

  for i = 1, numWeapon do
    print("buy r unit loop count",i)
    buy(buyType)
  end
  click("Right")
  msleep(200)
  
  for i = 1, numWeapon  do
    print("buy l unit loop count",i)
    buy(buyType)
  end
  click(CANCEL)
  waitLoad()
  msleep(400)
  click(CANCEL)

  waitGoto("GARAGE")
  waitLoad()
  msleep(400)
  click("RB")
  waitGoto("WORLD MENU")
  waitLoad()
  msleep(400)
  
  for i = 1, numWeapon/2 do
    print("mission loop count",i)
    mission(true)
  end

  click("LB")
  waitGoto("GARAGE")
  waitLoad()
  
  click(OK)
  waitGoto("ASSEMBLE")
  msleep(100)
  clickTrigger("RT")
  click("Down") -- right arm weapon
  click("Down")
  click(OK)
  click("Right") -- left arm weapon
  click("Down")
  click("Down")
  click(OK)
  click("Right") -- right hanger weapon
  click("Right")
  click("Right")
  click("Down")
  click("Down")
  click(OK)
  click("Right") -- left hanger weapon
  click("Down")
  click("Down")
  click(OK)
  click(CANCEL)
  msleep(200)
  click(CANCEL)
  msleep(200)
  waitLoad()
 
 
  waitGoto("GARAGE")
  waitLoad()
  click("Down")
  click("Down")
  click("Down")
  click("Down")
  click(OK)

  waitGoto("SHOP")
  msleep(400)
  click("Up")
  click(OK)
  
  waitGoto("SELL PARTS")
  waitLoad()
  msleep(400)
  
  moveWeaponInShop()
  msleep(100)

  for i= 1, numWeapon do
    click("Up")
  end
  
  click("Y")
  msleep(400)
  
  for i=1, numWeapon do
    print("sell r unit loop count",i)
    sell()
  end
  click("Y")
  msleep(400)
  click("Y")
  msleep(400)
  
  click("Right")
  msleep(100)
  
  for i= 1, numWeapon  do
    click("Up")
  end

  click("Y")
  msleep(400)  
  for i=1, numWeapon  do
    print("sell l unit loop count",i)
    sell()
  end
  
  click(CANCEL)
  msleep(100)
  click(CANCEL)
  
  waitGoto("SHOP")
  waitLoad()
  click(CANCEL)
  
  waitGoto("GARAGE")
  waitLoad()
  click("Up")
  click("Up")
  click("Up")
  click("Up")
  click(OK)
  
  waitGoto("ASSEMBLE")
  msleep(100)
  clickTrigger("RT")
  click("Up") -- right arm weapon
  click("Up")
  click(OK)
  click("Right") -- left arm weapon
  click("Up")
  click("Up")
  click(OK)
  click("Right") -- right hanger weapon
  click("Right")
  click("Right")
  click("Up")
  click("Up")
  click(OK)
  click("Right") -- left hanger weapon
  click("Up")
  click("Up")
  click(OK)
  click(CANCEL)
  msleep(200)
  click(CANCEL)
  msleep(200)
  waitLoad()

  waitGoto("GARAGE")
  waitLoad()
  click("Down")
  click("Down")
  click("Down")
  click("Down")
  click(OK)

  waitGoto("SHOP")
  msleep(400)

end

require("setting")

if XBOX ~= nil and XBOX == true then
  OK = "A"
  CANCEL = "B"
  START = "Start"
  BACK = "Back"
else
  OK = "B"
  CANCEL = "A"
  START = "Back"
  BACK = "Start"
end
